import java.util.*;

/**
 * Represents a unique state of the automaton.
 * A state manages the set of incoming and outgoing transitions 
 * from/to other states (or itself in case of a loop transition).
 */
public class State {
 	private String name;
  	private Set incomingTransitions;
  	private Set outgoingTransitions;
  	private boolean isStart;
  	private boolean isTerminal;
  	private int id; // used for housekeeping
  	
  	public State(String n, int i) {
  		name = n; id = i;
		isStart = false; isTerminal = false;
		incomingTransitions = new HashSet();
		outgoingTransitions = new HashSet();
  	}
  	
  	public String toString() {
  		return name;
  	}
  	
	// Standard setter/getter methods
	public int getId() { return id;}
	public Set getIncomingTransitions() {return incomingTransitions;}
	public String getName() {return name;}
	public Set getOutgoingTransitions() {return outgoingTransitions;}
	public void setId(int i) {id = i;}
	public void setIncomingTransitions(Set set) {incomingTransitions = set;}
	public void setName(String string) {name = string;}
	public void setOutgoingTransitions(Set set) {outgoingTransitions = set;}
	public boolean isStart() {return isStart;}
	public void setStart(boolean b) {isStart = b;}
	public boolean isTerminal() {return isTerminal;}
	public void setTerminal(boolean b) {isTerminal = b;}
}


